Subject: Re: [PATCH RFC 1/1] usb: Tell xhci when usb data might be misaligned

From: Mark Lord <[email-masked]>
Date: Thu, 30 Jan 2014 16:48:41 -0500

On 14-01-30 04:43 PM, Alan Stern wrote:
> On Thu, 30 Jan 2014, Sarah Sharp wrote:
> 
>> It should not matter what alignment or length of scatter-gather list the
>> upper layers pass the xHCI driver, it should just work.  I want to do
>> this fix right, by changing the fundamental way we queue TRBs to the
>> rings to fit the TD rules.  We should break each TD into fragment-sized
>> chunks, and add a link TRB in the middle of a segment where necessary.
> 
> That's a good plan.  However _some_ restriction will turn out to be
> necessary.
> 
> For example, what will you do if a driver submits an SG list containing
> 300 elements, each 3 bytes long?

Allocate a contiguous (bounce) buffer and copy the fragments to/from it?

-- 
Mark Lord
Real-Time Remedies Inc.
[email-masked]